Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# ACE_WIN32_Asynch_Read_Dgram Class Reference

This class is a factory for starting off asynchronous reads on a UDP socket. More...

`#include <WIN32_Asynch_IO.h>`

Inheritance diagram for ACE_WIN32_Asynch_Read_Dgram:

[legend]
Collaboration diagram for ACE_WIN32_Asynch_Read_Dgram:

[legend]
List of all members.

## Public Methods
| ACE_WIN32_Asynch_Read_Dgram (ACE_WIN32_Proactor *win32_proactor)
| Constructor.
virtual | ~ACE_WIN32_Asynch_Read_Dgram (void)
| Destructor.
virtual ssize_t | recv (ACE_Message_Block *message_block, size_t &number_of_bytes_recvd, int flags, int protocol_family, const void *act, int priority, int signal_number)
int | open (ACE_Handler &handler, ACE_HANDLE handle, const void *completion_key, ACE_Proactor *proactor)
int | cancel (void)
ACE_Proactor * | proactor (void) const
| Return the underlying proactor.
## Protected Methods
| ACE_WIN32_Asynch_Read_Dgram (void)
| Do-nothing constructor.

## Detailed Description

This class is a factory for starting off asynchronous reads on a UDP socket.

Once <open> is called, multiple asynchronous <read>s can be started using this class. An ACE_Asynch_Read_Dgram::Result will be passed back to the <handler> when the asynchronous reads completes through the <ACE_Handler::handle_read_stream> callback.

## Constructor & Destructor Documentation

ACE_WIN32_Asynch_Read_Dgram::ACE_WIN32_Asynch_Read_Dgram | ( | ACE_WIN32_Proactor * | win32_proactor | ) |

| Constructor.

ACE_WIN32_Asynch_Read_Dgram::~ACE_WIN32_Asynch_Read_Dgram | ( | void |  | ) | `[virtual]`

| Destructor.

ACE_WIN32_Asynch_Read_Dgram::ACE_WIN32_Asynch_Read_Dgram | ( | void |  | ) | `[protected]`

| Do-nothing constructor.

## Member Function Documentation

int ACE_WIN32_Asynch_Read_Dgram::cancel | ( | void |  | ) | `[virtual]`

| This cancels all pending accepts operations that were issued by the calling thread. The function does not cancel asynchronous operations issued by other threads. Reimplemented from ACE_WIN32_Asynch_Operation.

int ACE_WIN32_Asynch_Read_Dgram::open | ( | ACE_Handler & | handler,
|  | ACE_HANDLE | handle,
|  | const void * | completion_key,
|  | ACE_Proactor * | proactor
| ) | `[virtual]`

| Initializes the factory with information which will be used with each asynchronous call. If (<handle> == ACE_INVALID_HANDLE), <ACE_Handler::handle> will be called on the <handler> to get the correct handle. Reimplemented from ACE_WIN32_Asynch_Operation.

ACE_Proactor * ACE_WIN32_Asynch_Read_Dgram::proactor | ( | void |  | ) | const`[virtual]`

| Return the underlying proactor. Reimplemented from ACE_WIN32_Asynch_Operation.

ssize_t ACE_WIN32_Asynch_Read_Dgram::recv | ( | ACE_Message_Block * | message_block,
|  | size_t & | number_of_bytes_recvd,
|  | int | flags,
|  | int | protocol_family,
|  | const void * | act,
|  | int | priority,
|  | int | signal_number
| ) | `[virtual]`

| This starts off an asynchronous read. Upto <message_block->total_size()> will be read and stored in the <message_block>. <message_block>'s <wr_ptr> will be updated to reflect the added bytes if the read operation is successfully completed. Return code of 1 means immediate success and <number_of_bytes_recvd> will contain number of bytes read. The <ACE_Handler::handle_read_dgram> method will still be called. Return code of 0 means the IO will complete proactively. Return code of -1 means there was an error, use errno to get the error code. Scatter/gather is supported on WIN32 by using the <message_block->cont()> method. Up to ACE_IOV_MAX <message_block>'s are supported. Upto <message_block->size()> bytes will be read into each <message block> for a total of <message_block->total_size()> bytes. All <message_block>'s <wr_ptr>'s will be updated to reflect the added bytes for each <message_block> Implements ACE_Asynch_Read_Dgram_Impl.

The documentation for this class was generated from the following files:

- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/WIN32_Asynch_IO.h
- /export2/deucetmp/bala/release_try/ACE_wrappers/ace/WIN32_Asynch_IO.cpp